/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the CreateInsignConfigRequestFree type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateInsignConfigRequestFree{}

// CreateInsignConfigRequestFree struct for CreateInsignConfigRequestFree
type CreateInsignConfigRequestFree struct {
	ApiUrl string `json:"api_url"`
	WebUrl string `json:"web_url"`
	Username string `json:"username"`
	Password string `json:"password"`
}

// NewCreateInsignConfigRequestFree instantiates a new CreateInsignConfigRequestFree object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateInsignConfigRequestFree(apiUrl string, webUrl string, username string, password string) *CreateInsignConfigRequestFree {
	this := CreateInsignConfigRequestFree{}
	this.ApiUrl = apiUrl
	this.WebUrl = webUrl
	this.Username = username
	this.Password = password
	return &this
}

// NewCreateInsignConfigRequestFreeWithDefaults instantiates a new CreateInsignConfigRequestFree object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateInsignConfigRequestFreeWithDefaults() *CreateInsignConfigRequestFree {
	this := CreateInsignConfigRequestFree{}
	return &this
}

// GetApiUrl returns the ApiUrl field value
func (o *CreateInsignConfigRequestFree) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestFree) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *CreateInsignConfigRequestFree) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetWebUrl returns the WebUrl field value
func (o *CreateInsignConfigRequestFree) GetWebUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WebUrl
}

// GetWebUrlOk returns a tuple with the WebUrl field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestFree) GetWebUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WebUrl, true
}

// SetWebUrl sets field value
func (o *CreateInsignConfigRequestFree) SetWebUrl(v string) {
	o.WebUrl = v
}

// GetUsername returns the Username field value
func (o *CreateInsignConfigRequestFree) GetUsername() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Username
}

// GetUsernameOk returns a tuple with the Username field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestFree) GetUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Username, true
}

// SetUsername sets field value
func (o *CreateInsignConfigRequestFree) SetUsername(v string) {
	o.Username = v
}

// GetPassword returns the Password field value
func (o *CreateInsignConfigRequestFree) GetPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Password
}

// GetPasswordOk returns a tuple with the Password field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestFree) GetPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Password, true
}

// SetPassword sets field value
func (o *CreateInsignConfigRequestFree) SetPassword(v string) {
	o.Password = v
}

func (o CreateInsignConfigRequestFree) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateInsignConfigRequestFree) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["web_url"] = o.WebUrl
	toSerialize["username"] = o.Username
	toSerialize["password"] = o.Password
	return toSerialize, nil
}

type NullableCreateInsignConfigRequestFree struct {
	value *CreateInsignConfigRequestFree
	isSet bool
}

func (v NullableCreateInsignConfigRequestFree) Get() *CreateInsignConfigRequestFree {
	return v.value
}

func (v *NullableCreateInsignConfigRequestFree) Set(val *CreateInsignConfigRequestFree) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateInsignConfigRequestFree) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateInsignConfigRequestFree) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateInsignConfigRequestFree(val *CreateInsignConfigRequestFree) *NullableCreateInsignConfigRequestFree {
	return &NullableCreateInsignConfigRequestFree{value: val, isSet: true}
}

func (v NullableCreateInsignConfigRequestFree) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateInsignConfigRequestFree) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


